%% experiment 1
baseFolder = 'TestData/20120710_EDF_hsp70_shr3v1_MOe6i6/';

Folders = {'not_TG_ctrl/','not_TG_MO/','TG_ctrl/','TG_MO/'};
class = {'not_TG_ctrl','not_TG_MO','TG_ctrl','TG_MO'};

outputFolder = 'OutputData/20120710_EDF_hsp70_shr3v1_MOe6i6/';

Th = 0.4; % chosen to make ctrl group have around 2~2.5 rossetes.
Count = [];
Group = [];

for iif = 1:numel(Folders)
    folder = [outputFolder Folders{iif}];
    load([folder 'Record.mat'])    
    for j = 1:numel(Record)
        dt = Record{j};
        Count = [Count, sum( min( max(dt(:,5)' - Th,0) / (1-Th),1)) ];
        Group = [Group;  class(iif)];
    end
end


%% experiment 2
%...

%% BOXPLOT
figure(1);clf;
h = boxplot(Count, Group,  'notch','on', 'grouporder', class, 'labels',class , 'widths',0.25);

mx = zeros(1,4);
nx =  zeros(1,4);
for k = 1:4
    for j = 1:numel(Count)
        if(strcmp(Group{j}, class{k}) == 1)
            mx(k) = mx(k) + Count(j);
            nx(k) = nx(k) + 1;
        end
    end
end
mx = mx ./ nx;

set(h,'LineWidth', 1);
hold on
plot(mx,'dk','markersize',4,'LineWidth',1)
grid on;
export_fig([outputFolder, 'WeightedWithDetectionProb_average_rosette_number_per_image_boxPlot'], '-png','-m2');
