
function [Coeff] = soft_kmeans(B, X, knn, sigma)

if ~exist('knn', 'var') || isempty(knn),
    knn = 5;
end

if ~exist('sigma', 'var') || isempty(sigma),
    sigma = 1;
end

nframe=size(X,1);
nbase=size(B,1);

% find k nearest neighbors
XX = sum(X.*X, 2);
BB = sum(B.*B, 2);
D  = repmat(XX, 1, nbase)-2*X*B'+repmat(BB', nframe, 1);
% IDX = zeros(nframe, knn);
% Coeff = zeros(nframe, nbase);
% size(Coeff)
Sigma = sigma * sigma * 2;
% for i = 1:nframe,
% 	d = D(i,:);
% 	[dd, idx] = sort(d, 'ascend');
%     w = exp(-dd(1:knn) / Sigma);
%      Coeff(i,idx(1:knn)) = w'/sum(w);
% end
Coeff = exp(-D ./ Sigma);
Coeff = bsxfun(@rdivide, Coeff,  sum(Coeff,2)+1e-30  ) ;
% size(Coeff)
% % llc approximation coding
% II = eye(knn, knn);
% Coeff = zeros(nframe, nbase);
% for i=1:nframe
%    idx = IDX(i,:);
%    z = B(idx,:) - repmat(X(i,:), knn, 1);           % shift ith pt to origin
% 
%    C = z*z';                                        % local covariance
%    C = C + II*beta*trace(C);                        % regularlization (K>D)
%    w = C\ones(knn,1);
%    w = w/sum(w)      ;                              % enforce sum(w)=1
%    Coeff(i,idx) = w';
% 
% 
% 
% end
